/* 

  (c) 2015 Ing. Mauro Dalfreddo 
  Require jquery.js (>=1.9.1), jquery.xpath.js, moment.min.js

*/

function DavResource (url,displayname,creationdate,lastmodified,isfolder,contentlength,modifiedby) {
	this.url = url;
    this.displayname = displayname;
    this.creationdate = creationdate;
	this.lastmodified = lastmodified;
	this.isfolder = isfolder;
	this.contentlength = contentlength;
	this.modifiedby = modifiedby;
}
DavResource.resolver = function(prefix){
			return "http://www.w3.org/1999/xhtml";							
}
DavResource.utc2local = function(str) {
		var d = moment.utc(str).toDate();
		return moment(d).format('YYYY-MM-DD HH:mm:ss');
}
DavResource.getDAVResources = function(davurl) {
	var array = [];	
	
	$.ajax({	
	url: davurl,
	method: "PROPFIND",
	async: false,
	headers: { Depth: 1 } /* 0 = only the url-resource, 1 = the foldre and the resources contained , undefined = recurse subfolders */
	}).done(function(data){		
		var x = data.xml;				
		
		 try {
		$(x).xpath("//D:response",DavResource.resolver).each(function(){		
		
			var o = new DavResource(
					$(this).xpath("D:href",DavResource.resolver).text(),				
					$(this).xpath("D:propstat/D:prop/D:displayname",DavResource.resolver).text(),
					DavResource.utc2local($(this).xpath("D:propstat/D:prop/D:creationdate",DavResource.resolver).text()),
					DavResource.utc2local($(this).xpath("D:propstat/D:prop/D:getlastmodified",DavResource.resolver).text()),
					$(this).xpath("D:propstat/D:prop/D:iscollection",DavResource.resolver).text(),
					$(this).xpath("D:propstat/D:prop/D:getcontentlength",DavResource.resolver).text(),
					$(this).xpath("D:propstat/D:prop/Office:modifiedby",DavResource.resolver).text()
				);					
			array.push(o);
			
		});	
		} catch (e) {
				//alert(e.Message);
			}
	});
	return array;	
}
DavResource.getDAVResource = function(davurl) {
	var o = undefined;
	
	$.ajax({	
	url: davurl,
	method: "PROPFIND",
	async: false,
	headers: { Depth: 0 } /* 0 = only the url-resource, 1 = the foldre and the resources contained , undefined = recurse subfolders */
	}).done(function(data){		
		var x = data.xml;
		
	try {		
		$(x).xpath("//D:response",DavResource.resolver).each(function(){		
		
			o = new DavResource(
					$(this).xpath("D:href",DavResource.resolver).text(),				
					$(this).xpath("D:propstat/D:prop/D:displayname",DavResource.resolver).text(),
					DavResource.utc2local($(this).xpath("D:propstat/D:prop/D:creationdate",DavResource.resolver).text()),
					DavResource.utc2local($(this).xpath("D:propstat/D:prop/D:getlastmodified",DavResource.resolver).text()),
					$(this).xpath("D:propstat/D:prop/D:iscollection",DavResource.resolver).text(),
					$(this).xpath("D:propstat/D:prop/D:getcontentlength",DavResource.resolver).text(),
					$(this).xpath("D:propstat/D:prop/Office:modifiedby",DavResource.resolver).text()
				);					
					
		});	
		 
	} catch (e) {
				//alert(e.Message);
			}		
	});
	return o;	
}

DavResource.getDAVResourcesByUrl = function(davurl){
	var a = DavResource.getDAVResources(davurl);
	var ht = {};	
	jQuery.each(a,function(i,v){
		if(!v.isfolder)	
			ht[v.url] = v;
	});
	return ht;
}
